Loading...
Searching...
No Matches
form_lazy_expr.h

form_lazy_expr - form expressions: concept and class hierarchy More...

Go to the source code of this file.

## Classes

class | form_lazy_unop< Unop, Expr >
struct | is_form_lazy< form_lazy_unop< Unop, Expr > >
class | form_lazy_invert_rep< Expr >
class | form_lazy_invert< Expr >
struct | is_form_lazy< form_lazy_invert< Expr > >
class | form_lazy_transpose< Expr >
struct | is_form_lazy< form_lazy_transpose< Expr > >
class | form_lazy_add< Binop, Expr1, Expr2 >
struct | is_form_lazy< form_lazy_add< Binop, Expr1, Expr2 > >
class | form_lazy_multiply_rep< Expr1, Expr2 >
class | form_lazy_multiply< Expr1, Expr2 >
struct | is_form_lazy< form_lazy_multiply< Expr1, Expr2 > >

## Namespaces

namespace | rheolef
| This file is part of Rheolef.
namespace | rheolef::details

## Macros

#define | _RHEOLEF_form_lazy_unop(OP, NAME)
| -a, +a: see the form page for the full documentation
#define | _RHEOLEF_form_lazy_add(OP, NAME)
| a+b, a-b: see the form page for the full documentation

## Functions

| _RHEOLEF_form_lazy_unop (+, details::unary_plus) _RHEOLEF_form_lazy_unop(-
template<class Expr, class Sfinae = typename std::enable_if<details::is_form_lazy<Expr>::value, Expr>::type>
details::form_lazy_invert< Expr > | inv (const Expr &a)
| inv: see the form page for the full documentation
template<class Expr, class Sfinae = typename std::enable_if<details::is_form_lazy<Expr>::value, Expr>::type>
details::form_lazy_transpose< Expr > | trans (const Expr &a)
| trans: see the form page for the full documentation
| _RHEOLEF_form_lazy_add (+, plus) _RHEOLEF_form_lazy_add(-
template<class Expr1, class Expr2, class Sfinae1 = typename std::enable_if<details::is_form_lazy<Expr1>::value, Expr1>::type, class Sfinae2 = typename std::enable_if<details::is_form_lazy<Expr2>::value, Expr2>::type>
details::form_lazy_multiply< Expr1, Expr2 > | operator* (const Expr1 &a, const Expr2 &b)
| a*b: see the form page for the full documentation

## Detailed Description

form_lazy_expr - form expressions: concept and class hierarchy

Definition in file form_lazy_expr.h.

## Macro Definition Documentation

## _RHEOLEF_form_lazy_unop

#define _RHEOLEF_form_lazy_unop | ( |  | OP,
|  |  | NAME )

Value:
template<class Expr, class Sfinae = typename std::enable_if<details::is_form_lazy<Expr>::value, Expr>::type> \
details::form_lazy_unop<NAME,Expr> \
operator OP (const Expr& a) \
{ \
return details::form_lazy_unop<NAME,Expr> (NAME(),a); \
}

-a, +a: see the form page for the full documentation

Definition at line 276 of file form_lazy_expr.h.

## _RHEOLEF_form_lazy_add

#define _RHEOLEF_form_lazy_add | ( |  | OP,
|  |  | NAME )

Value:
template<class Expr1, class Expr2, \
class Sfinae1 = typename std::enable_if<details::is_form_lazy<Expr1>::value, Expr1>::type, \
class Sfinae2 = typename std::enable_if<details::is_form_lazy<Expr2>::value, Expr2>::type> \
details::form_lazy_add<details::NAME,Expr1,Expr2> \
operator OP (const Expr1& a, const Expr2& b) \
{ \
return details::form_lazy_add<details::NAME,Expr1,Expr2> (a,b); \
}

a+b, a-b: see the form page for the full documentation

Definition at line 599 of file form_lazy_expr.h.